3d8221f1b4316ccfa67defa524d48eb988ef604f
[profile] / dot / shell-rc
1 ### -*-sh-*-
2 ###
3 ### Common per-shell configuration.
4
5 ###--------------------------------------------------------------------------
6 ### Utilities.
7
8 __mdw_programp () { type >/dev/null 2>&1 "$1"; }
9
10 __mdw_source_if_exists () {
11 local i
12 for i in "$@"; do
13 if [ -r "$i" ]; then . "$i"; fi
14 done
15 }
16
17 ###--------------------------------------------------------------------------
18 ### Hooks.
19
20 __mdw_addhook () {
21 local hk=$1 fn=$2 t
22
23 eval t=\${$hk+t}
24 case $t in t) ;; *) echo >&2 "unknown hook \`$hk'"; return 2; esac
25
26 eval t=\$$hk
27 case " $t " in
28 *" $fn "*) ;;
29 *) eval "$hk=\${$hk:+\$$hk }\$fn" ;;
30 esac
31 }
32
33 __mdw_delhook () {
34 local hk=$1 fn=$2 t l r
35
36 eval t=\${$hk+t}
37 case $t in t) ;; *) echo >&2 "unknown hook \`$hk'"; return 2; esac
38
39 eval t=\" \$$hk \"
40 case $t in
41 *" $fn "*)
42 l=${t%% $fn*} r=${t##*$fn }
43 l=${l# } r=${r% }
44 eval "$hk=\$l\${l:+ }\$r"
45 ;;
46 esac
47 }
48
49 __mdw_setrc () { return $1; }
50
51 __mdw_runhook () {
52 local hk=$1 saverc=$? t i; shift
53
54 eval t=\${$hk+t}
55 case $t in t) ;; *) echo >&2 "unknown hook \`$hk'"; return 2; esac
56
57 eval t=\$$hk
58 for i in $t; do __mdw_setrc $saverc; "$i" "$@"; done
59 }
60
61 ###--------------------------------------------------------------------------
62 ### Prompt machinery.
63
64 __mdw_host=$(hostname)
65 __mdw_hqual=
66 __mdw_hqual=$__mdw_hqual${SCHROOT_CHROOT_NAME+/$SCHROOT_CHROOT_NAME}
67 __mdw_hqual=$__mdw_hqual${CROSS_BUILDENV+/$CROSS_BUILDENV}
68 __mdw_set_prompt_hacks () { host=$__mdw_host; dir=""; }
69
70 __mdw_system=$(uname -s)
71 : ${USER-${LOGNAME-$(id -un)}}
72 __mdw_user=$USER
73
74 case $(id -u) in
75 0)
76 __mdw_rootp=t
77 ;;
78 *)
79 case $__mdw_system in
80 CYGWIN_*)
81 case " $(id -G) " in
82 *" 544 "*) __mdw_rootp=t __mdw_user="$__mdw_user%admin" ;;
83 *) __mdw_rootp=nil ;;
84 esac
85 ;;
86 *)
87 __mdw_rootp=nil
88 ;;
89 esac
90 esac
91
92 __mdw_set_prompt_pieces () {
93
94 ## Fancy highlighting in some terminals.
95 local bold unbold nl gitcolour rccolour uncolour
96 local host dir more
97 bold="" unbold="" nl="" gitcolour="" rccolour="" uncolour="" more=""
98 __mdw_set_prompt_hacks
99
100 ## Choose the right delimiters. Highlight root prompts specially;
101 ## highlight when I'm running as some other user. Highlight when this
102 ## isn't the outermost shell on the terminal.
103 local left right u tty
104 case $__mdw_rootp in
105 t)
106 left=$(echo « | iconv -f UTF-8 -t //translit)
107 right=$(echo » | iconv -f UTF-8 -t //translit)
108 ;;
109 nil)
110 case $USER in
111 mdw | mwooding | nemo) u="" left="[" right="]" ;;
112 *) u="$__mdw_user@" left="{" right="}" ;;
113 esac
114 tty=$(tty)
115 case "$__mdw_tty" in
116 "$tty") left="<" right=">" ;;
117 *) __mdw_tty=$tty; export __mdw_tty ;;
118 esac
119 ;;
120 esac
121
122 ## If this session is insecure then highlight that.
123 local sec_l sec_r h
124 h=$(hostname)
125 case ${SSH_CLIENT-nil},${SCHROOT_CHROOT_NAME-nil},$__mdw_sechost in
126 nil,nil,"$h") sec_l="" sec_r="" ;;
127 nil,nil,*) sec_l="(" sec_r=")" ;;
128 *) sec_l="" sec_r=""
129 esac
130
131 ## If this is an schroot environment or some other interesting augmented
132 ## environment then point this out.
133
134 ## Put together the main pieces.
135 __mdw_prompt_left="$nl$bold$left$sec_l$u$host$__mdw_hqual$sec_r$dir"
136 __mdw_prompt_git_left="$unbold$gitcolour"
137 __mdw_prompt_git_right="$uncolour$bold"
138 __mdw_prompt_rc_left="$unbold$rccolour"
139 __mdw_prompt_rc_right="$uncolour$bold"
140 __mdw_prompt_right="$right$unbold"
141 __mdw_prompt_more=" $more$bold>$unbold "
142 }
143
144 __mdw_set_prompt () {
145 case "${TERM-dumb}:${INSIDE_EMACS+$INSIDE_EMACS}" in
146 dumb:)
147 case $(id -u) in 0) PS1='# ' ;; *) PS1='$ ' ;; esac
148 PS2='> '
149 ;;
150 *)
151 __mdw_last_rc=$?
152 local git rc
153 if type __git_ps1 >/dev/null 2>&1; then
154 git="$__mdw_prompt_git_left$(__git_ps1)$__mdw_prompt_git_right"
155 else
156 git=""
157 fi
158 case $__mdw_last_rc in
159 0) rc="" ;;
160 *) rc="$__mdw_prompt_rc_left rc=$__mdw_last_rc$__mdw_prompt_rc_right" ;;
161 esac
162 PS1="$__mdw_prompt_left$git$rc$__mdw_prompt_right"
163 PS2="$PS1$__mdw_prompt_more"
164 unset __mdw_last_rc
165 ;;
166 esac
167 }
168
169 __mdw_xterm_settitle () {
170 printf >/dev/tty \
171 "\e]2;%s@%s:%s – %s\e\\" \
172 "$__mdw_user" "$__mdw_host$__mdw_hqual" "$PWD" \
173 "$1"
174 }
175 __mdw_xterm_precmd () { __mdw_xterm_settitle "$__mdw_shell"; }
176 __mdw_xterm_preexec () { __mdw_xterm_settitle "$1"; }
177
178 __mdw_screen_settitle () {
179 printf >/dev/tty \
180 "\ek%s\e\\" \
181 "$1"
182 }
183 __mdw_screen_precmd () { __mdw_screen_settitle "$__mdw_shell"; }
184 __mdw_screen_preexec () { __mdw_screen_settitle "$1"; }
185
186 if [ -t 0 ]; then
187 case ${STY+t},${__mdw_precmd_hook+t},${__mdw_preexec_hook+t},${TERM} in
188 ,t,t,xterm*)
189 __mdw_addhook __mdw_precmd_hook __mdw_xterm_precmd
190 __mdw_addhook __mdw_preexec_hook __mdw_xterm_preexec
191 ;;
192 t,t,t,*)
193 __mdw_addhook __mdw_precmd_hook __mdw_screen_precmd
194 __mdw_addhook __mdw_preexec_hook __mdw_screen_preexec
195 ;;
196 esac
197 case ${__mdw_precmd_hook+t} in
198 t) __mdw_addhook __mdw_precmd_hook __mdw_set_prompt ;;
199 esac
200 fi
201
202 ###--------------------------------------------------------------------------
203 ### Some handy aliases.
204
205 alias cx='chmod +x'
206 alias which="command -v"
207 alias rc="rc -l"
208 rootly () {
209 case $# in 0) set -- "${SHELL-/bin/sh}" ;; esac
210 $__MDW_ROOTLY "$@"
211 }
212 alias r=rootly
213 alias re="rootly $EDITOR"
214 alias pstree="pstree -hl"
215 alias cdtmp='cd ${TMPDIR-/tmp}'
216 alias pushtmp='pushd ${TMPDIR-/tmp}'
217 alias e="$EDITOR"
218 alias svn="svnwrap svn"
219 alias @="ssh"
220 alias make="nice make"
221 alias cross-run="nice cross-run"
222 alias gdb="gdb -q"
223
224 ## Shut up Lisp interpreters.
225 alias clisp="clisp -q -q"
226 alias cmucl="rlwrap cmucl -quiet"
227 alias ecl="rlwrap ecl"
228 alias sbcl="rlwrap sbcl --noinform"
229 alias ccl="rlwrap ccl"
230 alias ccl32="rlwrap ccl32"
231 alias ccl64="rlwrap ccl64"
232 alias abcl="rlwrap abcl --noinform"
233
234 ###--------------------------------------------------------------------------
235 ### Colour output.
236
237 ## Arrange for `ls' output to be in colour.
238 if __mdw_programp dircolors; then eval $(dircolors -b "$HOME/.dircolors")
239 else unset LS_COLORS; fi
240
241 unalias ls 2>/dev/null || :
242 ls () {
243 if [ -t 1 ]; then command ls $LS_OPTIONS ${LS_COLORS+--color=auto} "$@"
244 else command ls "$@"; fi
245 }
246
247 ## Arrange for `grep' output to be in colour.
248 export GREP_COLORS="mt=01;31:ms=01;31:mc=031;31:fn=36:ln=36:bn=36:se=34"
249
250 greplike () {
251 local grep=$1; shift
252 if [ -t 1 ]; then
253 command $grep ${GREP_COLORS+--color=always} "$@" | mdw-pager
254 else
255 command $grep "$@"
256 fi
257 }
258 alias grep="greplike grep"
259 alias egrep="greplike egrep"
260 alias fgrep="greplike fgrep"
261 alias zgrep="greplike zgrep"
262
263 ## Arrange for `diff' output to be in colour.
264 export DIFF_COLORS="hd=1:ln=36:ad=32:de=31"
265 difflike () {
266 local diff=$1; shift
267 if [ -t 1 ]; then
268 command $diff \
269 ${DIFF_COLORS+--color=always} \
270 ${DIFF_COLORS+--palette="$DIFF_COLORS"} \
271 "$@" | mdw-pager
272 else
273 command $diff "$@" | cat
274 fi
275 }
276 alias diff="difflike diff"
277
278 ###--------------------------------------------------------------------------
279 ### Other hacks.
280
281 ## Turn off pagers inside Emacs shell buffers.
282 case "$INSIDE_EMACS" in
283 2[2-9].*,comint | [3-9][0-9].*,comint) export PAGER=cat ;;
284 esac
285
286 ###--------------------------------------------------------------------------
287 ### More complicated shell functions.
288
289 ## xt [@HOST] XTERM-ARGS
290 ##
291 ## Open a terminal, maybe on a remote host.
292 xt () {
293 case "$1" in
294 @*)
295 local remote=${1#@} title
296 shift
297 if [ $# -gt 0 ]; then
298 title="xterm [$remote] $1"
299 else
300 title="xterm [$remote]"
301 fi
302 (xterm -title "$title" -e ssh $remote "$@" &)
303 ;;
304 *)
305 (xterm "$@" &)
306 ;;
307 esac
308 }
309
310 ## core [y|n]
311 ##
312 ## Tweak core dumps on and off, or show the current status.
313 core () {
314 case "x$1" in
315 xon|xy|xyes) ulimit -Sc $(ulimit -Hc) ;;
316 xoff|xn|xno) ulimit -Sc 0 ;;
317 x)
318 local l=$(ulimit -Sc)
319 case $l in
320 0) echo "Core dumps disabled" ;;
321 unlimited) echo "Core dumps enabled" ;;
322 *) echo "Core dump limit is $l blocks" ;;
323 esac
324 ;;
325 *)
326 echo >&2 "usage: core [y|n]"
327 return 1
328 ;;
329 esac
330 }
331
332 ## world [NAME]
333 ##
334 ## Set current security world to NAME. With no NAME, print the currently
335 ## selected world.
336 world () {
337 local nfast=${NFAST_HOME-/opt/nfast}
338 local kmdata
339 case "$#" in
340 0)
341 echo "${NFAST_KMDATA#$nfast/kmdata-}"
342 ;;
343 *)
344 if [ -d "$1" ]; then
345 kmdata=$1
346 elif [ -d "$nfast/kmdata-$1" ]; then
347 kmdata=$nfast/kmdata-$1
348 else
349 echo >&2 "world: can't find world $1"
350 return 1
351 fi
352 shift
353 case "$#" in
354 0) export NFAST_KMDATA=$kmdata ;;
355 *) "$@" ;;
356 esac
357 ;;
358 esac
359 }
360
361 ## path-add [VAR] DIR
362 ##
363 ## Add DIR to the beginning of PATH-like variable VAR (defaults to PATH) if
364 ## it's not there already.
365 path_add () {
366 local pathvar export dir val
367 case $# in
368 1) pathvar=PATH dir=$1 export="export PATH" ;;
369 2) pathvar=$1 dir=$2 export=: ;;
370 *) echo >&2 "Usage: $0 [VAR] DIR"; return 1 ;;
371 esac
372 eval val=\$$pathvar
373 case ":$val:" in
374 *:"$dir":*) ;;
375 *) val=$dir:$val ;;
376 esac
377 eval $pathvar=\$val
378 eval $export
379 }
380
381 ## path-remove [VAR] DIR
382 ##
383 ## Remove DIR from PATH-like variable VAR (defaults to PATH); it's not an
384 ## error if DIR isn't in VAR.
385 path_remove () {
386 local pathvar export dir val
387 case $# in
388 1) pathvar=PATH dir=$1 export="export PATH" ;;
389 2) pathvar=$1 dir=$2 export=: ;;
390 *) echo >&2 "Usage: $0 [VAR] DIR"; return 1 ;;
391 esac
392 eval val=\$$pathvar
393 case ":$val:" in
394 :"$dir":) val= ;;
395 :"$dir":*) val=${val#$dir:} ;;
396 *:"$dir":) val=${val%:$dir} ;;
397 *:"$dir":*) val=${val%%:$dir:*}:${val#*:$dir:} ;;
398 esac
399 eval $pathvar=\$val
400 eval $export
401 }
402
403 ## pathhack [-f] +HACK|-HACK...
404 ##
405 ## Each HACK refers to a subdirectory of `~/bin/hacks'. A hack name preceded
406 ## by `+' adds the directory to the PATH; a `-' removes. Adding a hack
407 ## that's already on the PATH doesn't do anything unless `-f' is set, in
408 ## which case it gets moved to the beginning. With no arguments, print the
409 ## currently installed hacks.
410 pathhack () {
411 local p e force arg hack dir
412 p=$PATH
413 if [ $# -eq 0 ]; then
414 while :; do
415 e=${p%%:*}
416 case "$e" in "$HOME/bin/hacks/"*) echo ${e#$HOME/bin/hacks/} ;; esac
417 case "$p" in *:*) p=${p#*:} ;; *) break ;; esac
418 done
419 return
420 fi
421 force=nil
422 while [ $# -gt 0 ]; do
423 arg=$1
424 case "$arg" in
425 -f | --force) force=t; shift; continue ;;
426 --) shift; break ;;
427 [-+]*) ;;
428 *) break; ;;
429 esac
430 hack=${arg#[+-]}
431 dir=$HOME/bin/hacks/$hack
432 if ! [ -d "$dir" ]; then
433 echo "$0: path hack $hack not found"
434 return 1
435 fi
436 case "$arg,$force,:$PATH:" in
437 -*,*,*:"$dir":*) path_remove p "$dir" ;;
438 +*,t,*:"$dir":*) path_remove p "$dir"; path_add p "$dir" ;;
439 +*,nil,*:"$dir":*) ;;
440 +*,*) path_add p "$dir" ;;
441 esac
442 shift
443 done
444 if [ $# -eq 0 ]; then PATH=$p; export PATH
445 else PATH=$p "$@"; fi
446 }
447
448 ###--------------------------------------------------------------------------
449 ### Finishing touches.
450
451 ## Make sure `$HOME/bin' is on the path.
452 path_add "$HOME/bin"
453
454 ## Set the temporary directory again. (A setuid or setgid program may have
455 ## unhelpfully forgotten this for us.)
456 case ${TMPDIR+t} in
457 t) ;;
458 *) if __mdw_programp tmpdir; then eval $(tmpdir -b); fi ;;
459 esac
460
461 ## For `root' use -- some simple molly-guards.
462 case $(id -u) in
463 0)
464 alias rm="rm -i" cp="cp -i" mv="mv -i"
465 set -o noclobber
466 ;;
467 esac
468
469 ## Run any local hooks.
470 __mdw_source_if_exists "$HOME/.shell-local"
471
472 ###----- That's all, folks --------------------------------------------------